import 'package:hbase/base/interface/main.dart';

// ignore: strong_mode_not_instantiated_bound
abstract class Presenter<V extends IView, I extends IInteractor>
    implements IPresenter<V, I> {
  V mView;
  I mInteractor;
  ContainerView mContainerView;

  // ignore: duplicate_constructor_default
  Presenter(ContainerView container){
    init(container, null);
  }

  // ignore: duplicate_constructor_default
  Presenter(ContainerView container,data){
      init(container, data);
  }
  void init(ContainerView containerView, data) {
    mContainerView = containerView;
    mInteractor = onCreateInteractor();
    mView = onCreateView(data);
    mView.setPresenter(this);
  }

  I getInteractor() {
    return mInteractor;
  }

  V getView() {
    return mView;
  }

  @override
  void back() {
    mContainerView.back();
  }
}
